## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated using the scripts at https://pagure.io/fedora-cosmic/cosmic-packaging/blob/main/f/scripts
ExcludeArch: %{ix86}
# Generated by rust2rpm 26
%bcond_without check


# While our version corresponds to an upstream tag, we still need to define
# these macros in order to set the VERGEN_GIT_SHA and VERGEN_GIT_COMMIT_DATE
# environment variables in multiple sections of the spec file.
%global commit fd44edf79b5ffbced27540fd222e37aa05daeeba
%global commitdatestring 2024-10-09 22:47:25 +0200
%global cosmic_minver 1.0.0~alpha.4

Name:           cosmic-bg
Version:        1.0.0~alpha.4
Release:        %autorelease
Summary:        Background manager for the COSMIC Desktop Environment

License:        (0BSD OR Apache-2.0 OR MIT) AND Apache-2.0 AND (Apache-2.0 OR Apache-2.0 WITH LLVM-exception OR MIT) AND (Apache-2.0 OR BSD-2-Clause OR MIT) AND (Apache-2.0 OR MIT) AND (Apache-2.0 OR MIT OR Zlib) AND BSD-3-Clause AND BSL-1.0 AND CC0-1.0 AND ISC AND MIT AND (MIT OR Unlicense) AND MPL-2.0

URL:            https://github.com/pop-os/cosmic-bg

Source0:        https://github.com/pop-os/cosmic-bg/archive/epoch-%{version_no_tilde}/cosmic-bg-%{version_no_tilde}.tar.gz
# To create the below sources:
# * git clone https://github.com/pop-os/cosmic-bg at the specified commit
# * cargo vendor > vendor-config-%%{version_no_tilde}.toml
# * tar -pczf vendor-%%{version_no_tilde}.tar.gz vendor
Source1:        vendor-%{version_no_tilde}.tar.gz
# * mv vendor-config-%%{version_no_tilde}.toml ..
Source2:        vendor-config-%{version_no_tilde}.toml

BuildRequires:  cargo-rpm-macros >= 25
BuildRequires:  rustc
BuildRequires:  lld
BuildRequires:  cargo
BuildRequires:  wayland-devel
BuildRequires:  libxkbcommon-devel
BuildRequires:  just
BuildRequires:  desktop-file-utils

Requires:       cosmic-icon-theme >= %{cosmic_minver}
Requires:       desktop-backgrounds-compat

%global _description %{expand:
%{summary}.}

%description %{_description}

%prep
%autosetup -n cosmic-bg-epoch-%{version_no_tilde} -p1 -a1
%cargo_prep -N
# Check if .cargo/config.toml exists
if [ -f .cargo/config.toml ]; then
  # If it exists, append the contents of %%{SOURCE2} to .cargo/config.toml
  cat %{SOURCE2} >> .cargo/config.toml
  echo "Appended %{SOURCE2} to .cargo/config.toml"
else
  # If it does not exist, append the contents of %%{SOURCE2} to .cargo/config
  cat %{SOURCE2} >> .cargo/config
  echo "Appended %{SOURCE2} to .cargo/config"
fi

%build
# Set vergen environment variables
export VERGEN_GIT_COMMIT_DATE="date --utc '%{commitdatestring}'"
export VERGEN_GIT_SHA="%{commit}"
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
%{cargo_vendor_manifest}
sed 's/\(.*\) (.*#\(.*\))/\1+git\2/' -i cargo-vendor.txt

%install
# Set vergen environment variables
export VERGEN_GIT_COMMIT_DATE="date --utc '%{commitdatestring}'"
export VERGEN_GIT_SHA="%{commit}"
just rootdir=%{buildroot} prefix=%{_prefix} install

# Set default background to system branding
sed -e 's|source: Path(".*"),|source: Path("/usr/share/backgrounds/default-dark.png"),|' -i %{buildroot}%{_datadir}/cosmic/com.system76.CosmicBackground/v1/all

# Set default setting for backgrounds on all displays
echo "true" > %{buildroot}%{_datadir}/cosmic/com.system76.CosmicBackground/v1/same-on-all 

# COSMIC is not a valid category pre-fedora 41
%if %{defined fedora} && 0%{?fedora} < 41
desktop-file-install \
--remove-category COSMIC \
--add-category X-COSMIC \
--delete-original \
--dir %{buildroot}%{_datadir}/applications \
%{buildroot}%{_datadir}/applications/com.system76.CosmicBackground.desktop
%endif

%check
desktop-file-validate %{buildroot}%{_datadir}/applications/com.system76.CosmicBackground.desktop
%if %{with check}
# Set vergen environment variables
export VERGEN_GIT_COMMIT_DATE="date --utc '%{commitdatestring}'"
export VERGEN_GIT_SHA="%{commit}"
%cargo_test
%endif

%files
%license LICENSE.md
%license LICENSE.dependencies
%license cargo-vendor.txt
%doc README.md
%{_bindir}/cosmic-bg
%{_datadir}/applications/com.system76.CosmicBackground.desktop
%{_datadir}/icons/hicolor/scalable/apps/com.system76.CosmicBackground.svg
%{_datadir}/icons/hicolor/symbolic/apps/com.system76.CosmicBackground-symbolic.svg
%dir %{_datadir}/cosmic/com.system76.CosmicBackground
%{_datadir}/cosmic/com.system76.CosmicBackground/*
%{_metainfodir}/com.system76.CosmicBackground.metainfo.xml

%changelog
## START: Generated by rpmautospec
* Fri Dec 06 2024 Ryan Brue <ryanbrue.dev@gmail.com> - 1.0.0~alpha.4-1
- "Update to 1.0.0~alpha.4"

* Sun Nov 03 2024 Neal Gompa <ngompa@fedoraproject.org> - 1.0.0~alpha.3-2
- Use system backgrounds by default

* Fri Nov 01 2024 Ryan Brue <ryanbrue.dev@gmail.com> - 1.0.0~alpha.3-1
- "Update to 1.0.0~alpha.3"

* Sun Sep 29 2024 Ryan Brue <ryanbrue.dev@gmail.com> - 1.0.0~alpha.2-1
- "Update to 1.0.0~alpha.2"
## END: Generated by rpmautospec
